/*-----------------------------------------------------------------------------------------------
Author     : Gui Manders
Company    : Husky Energy
Description: A utility class for Fluid Management / Run Sheets
-------------------------------------------------------------------------------------------------*/

global class FM_Utilities
{
    ////////////////////////////////
    //* CONSTANTS -> PERMISSIONS *//
    ////////////////////////////////

    public static final String FLUID_PERMISSION_SET_OPERATOR = 'HOG_Field_Operator';
    public static final String FLUID_PERMISSION_SET_DISPATCH_STANDARD = 'HOG_FM_Dispatcher';
    public static final String FLUID_PERMISSION_SET_DISPATCH_VENDOR = 'HOG_FM_Dispatcher_Vendor';
    public static final String FLUID_PERMISSION_SET_FLUID_ADMIN = 'HOG_Fluid_Management_Admin';
    public static final String HOG_PERMISSION_SET_CONTROL_ROOM_OPERATOR = 'HOG_Control_Room_Operator_New';
    public static final String SAND_PERMISSION_SET_SAND_LEAD = 'HOG_Sand_Management_Lead';

    ////////////////////////////////////////
    //* CONSTANTS -> TRUCK LIST STATUSES *//
    ////////////////////////////////////////

    public static final String TRUCKLIST_STATUS_CARRYOVER = 'Carryover';
    public static final String TRUCKLIST_STATUS_CANCELLED = 'Cancelled';
    public static final String TRUCKLIST_STATUS_PENDING = 'Pending';
    public static final String TRUCKLIST_STATUS_BOOKED = 'Booked';
    public static final String TRUCKLIST_STATUS_GIVENBACK = 'Given Back';
    public static final String TRUCKLIST_STATUS_DISPATCHED = 'Dispatched';
    public static final String TRUCKLIST_STATUS_ADDON = 'Add On';
    public static final String TRUCKLIST_STATUS_EXPORTED = 'Exported';
    public static final String TRUCKLIST_STATUS_COMPLETED = 'Completed';
    public static final String TRUCKLIST_STATUS_NONE = '';

    //////////////////////////////////
    //* CONSTANTS -> LOAD STATUSES *//
    //////////////////////////////////
    public static final String TRUCKTRIP_STATUS_NEW = 'New';
    public static final String TRUCKTRIP_STATUS_CARRYOVER = 'Carryover';
    public static final String TRUCKTRIP_STATUS_REDISPATCH = 'Redispatch';
    public static final String TRUCKTRIP_STATUS_BOOKED = 'Booked';
    public static final String TRUCKTRIP_STATUS_GIVENBACK = 'Given Back';
    public static final String TRUCKTRIP_STATUS_DISPATCHED = 'Dispatched';
    public static final String TRUCKTRIP_STATUS_ADDON = 'Add On';
    public static final String TRUCKTRIP_STATUS_EXPORTED = 'Exported';
    public static final String TRUCKTRIP_STATUS_COMPLETED = 'Completed';
    public static final String TRUCKTRIP_STATUS_CANCELLED = 'Cancelled';
    public static final String TRUCKTRIP_STATUS_UNCANCELLED = 'Uncancelled';

    /////////////////////////////////////////
    //* CONSTANTS -> STUCK TRUCK STATUSES *//
    /////////////////////////////////////////
    public static final String STUCK_TRUCK_STATUS_STUCK = 'Stuck';
    public static final String STUCK_TRUCK_STATUS_UNSTUCK = 'Unstuck';

    ///////////////////////
    //* Dispatch Shifts *//
    ///////////////////////
    public static final String DISPATCH_SHIFT_DAY_TODAY = 'Day - Today';
    public static final String DISPATCH_SHIFT_NIGHT_TODAY = 'Night - Today';
    public static final String DISPATCH_SHIFT_DAY_TOMORROW = 'Day - Tomorrow';
    public static final String DISPATCH_SHIFT_TONIGHT_YESTERDAY = 'Night - Yesterday';
    public static final Map<String, String> dispatchShiftOptionValues = new Map<String, String> {
        DISPATCH_SHIFT_DAY_TODAY => 'day:today', DISPATCH_SHIFT_NIGHT_TODAY => 'night:today', 
        DISPATCH_SHIFT_DAY_TOMORROW => 'day:tomorrow', DISPATCH_SHIFT_TONIGHT_YESTERDAY => 'night:yesterday'};


    /////////////////////////////
    //* Dispatch Cutoff Times *//
    /////////////////////////////
    public static final String DAY_DISPATCH_CUTOFF_HOUR = '18:00';
    public static final String NIGHT_DISPATCH_CUTOFF_HOUR = '9:00';

    //////////////////////////////////
    //* CONSTANTS -> LOCATION DATA *//
    //////////////////////////////////

    private static final String QUERY_LOCATION_LIST_FROM_TANKS = 'SELECT Equipment__r.Location__r.Id, Equipment__r.Location__r.Name, Equipment__r.Location__r.Status__c, Equipment__r.Location__r.Fluid_Location_Ind__c FROM Equipment_Tank__c WHERE Equipment__r.Location__r.Route__c = \'!!ROUTENUM!!\' AND Tank_Settings__c <> \'Hidden - Hide this Tank from the selectable list.\' AND ((Equipment__r.Location__r.Functional_Location_Category__c IN :RUNSHEET_FUNCTIONAL_LOCATION_CATEGORIES AND Equipment__r.Location__r.Status__c IN :RUNSHEET_WELL_INCLUDED_STATUSES AND Equipment__r.Location__r.Well_Type__c IN :RUNSHEET_WELL_TYPES) OR (Tank_Settings__c = \'Override - Display this Tank / Location\')) ORDER BY Equipment__r.Location__r.Status__c, Equipment__r.Location__r.Name LIMIT 1000';
    private static final String QUERY_SINGLE_LOCATION_TANKS = 'SELECT Id, Door_Status__c, Equipment__c, Last_Inspection_Date__c, Latest_Tank_Reading_Date__c, Low_Level__c, SCADA_Tank_Level__c, Serial_Number__c, Equipment__r.Manufacturer_Serial_No__c, Tank_Label__c, Tank_Size_m3__c, Tank_Status__c FROM Equipment_Tank__c WHERE Equipment__r.Location__r.Id = \'!!LOCATION!!\' AND Tank_Settings__c <> \'Hidden - Hide this Tank from the selectable list.\' AND ((Equipment__r.Location__r.Functional_Location_Category__c IN :RUNSHEET_FUNCTIONAL_LOCATION_CATEGORIES AND Equipment__r.Location__r.Status__c IN :RUNSHEET_WELL_INCLUDED_STATUSES AND Equipment__r.Location__r.Well_Type__c IN :RUNSHEET_WELL_TYPES) OR (Tank_Settings__c = \'Override - Display this Tank / Location\')) ORDER BY Tank_Label__c, Equipment__r.Name LIMIT 1000';

    public static final String LOCATION_INDEX_ALL_WELLS = 'all_wells';
    public static final String LOCATION_INDEX_SELECTED_WELLS = 'selected_wells';
    public static final String LOCATION_INDEX_LOCATION_LIST = 'location_list';

    //////////////////////////////////////////////
    //* CONSTANTS -> DISPATCH DESTINATION DATA *//
    //////////////////////////////////////////////
    public static final String QUERY_DISPATCH_TRUCK_TRIPS = ' SELECT Name '
            + ' ,Run_Sheet_Date__c '
            + ' ,Load_Request__r.Name '
            + ' ,Load_Request__r.Source_Location__c '
            + ' ,Load_Request__r.Source_Facility__c '
            + ' ,Load_Request__r.Sour__c '
            + ' ,Load_Request__r.Equipment_Tank__r.SCADA_Tank_Level__c '
            + ' ,Load_Request__r.Equipment_Tank__r.Latest_Tank_Reading_Date__c '
            + ' ,Load_Request__r.Equipment_Tank__r.Low_Level__c '
            + ' ,Load_Request__r.Tank_Low_Level__c '
            + ' ,Load_Request__r.Tank_Size__c '
            + ' ,Load_Request__r.Act_Tank_Level__c '
            + ' ,Load_Request__r.Act_Flow_Rate__c '
            + ' ,Load_Request__r.Flowline_Volume__c '
            + ' ,Load_Request__r.Source_Location__r.Well_Type__c '
            + ' ,Load_Request__r.Source_Facility__r.Facility_Name_For_Fluid__c '
            + ' ,Load_Request__r.Source_Location__r.Fluid_Location_Ind__c '
            + ' ,Load_Request__r.Load_Weight__c '
            + ' ,Route__c '
            + ' ,Route_Id__c '
            + ' ,Sour__c '
            + ' ,Product__c '
            + ' ,Run_Sheet_Lookup__r.Outstanding_Load__c '
            + ' ,Run_Sheet_Lookup__r.Facility__c'
            + ' ,Standing_Comments__c '
            + ' ,Axle__c '
            + ' ,Unit_Configuration__c '
            + ' ,Facility_Type__c '
            + ' ,Facility_Lookup__r.Facility_Name_For_Fluid__c '
            + ' ,Location_Lookup__r.Location_Name_For_Fluid__c '
            + ' ,Carrier__r.Carrier_Name_For_Fluid__c '
            + ', Carrier__c'    
            + ' ,Shift__c '
            + ' ,Unit__r.Name '
            + ' ,Priority__c '
            + ' ,Tank__c '
            + ' ,Truck_Trip_Status__c '
            + ' ,Load_Type__c '
            + ' ,Well__c '
            + ' ,Load_Weight__c '
            + ' ,Facility__c '
            + ' ,Load_Request_Cancel_Reason__c '
            + ' ,Shift_Day__c '
            + ' FROM FM_Truck_Trip__c ';
    public static final String DESTINATION_INDEX_ALL_DESTINATIONS = 'all_dispatch_destinations';
    public static final String DESTINATION_INDEX_FAVORITE_DESTINATIONS = 'favorite_dispatch_destinations';
    public static final String DESTINATION_PICKLIST_SEPERATOR_FAVORITE = 'Favorite';
    public static final String DESTINATION_PICKLIST_SEPERATOR_ALL = 'All';


    //////////////////////////////////////////////////
    //* CONSTANTS -> TRUCKTRIP DATA & CONFIGURATION *//
    //////////////////////////////////////////////////
    public static final String QUERY_TRUCKTRIP_EXPORT_IMPORT = 'SELECT'
                    + ' Id'
                    + ', Name'
                    + ', Route__c'
                    + ', Well__c'
                    + ', Tank__c'
                    + ', Shift__c'
                    + ', Shift_Day__c'
                    + ', Product__c'
                    + ', Load_Type__c'
                    + ', Standing_Comments__c'
                    + ', Unit_Configuration__c'
                    + ', Load_Weight__c'
                    + ', Sour__c'
                    + ', Truck_Trip_Status__c'
                    + ', Load_Request__c'
                    + ', Load_Request__r.CreatedDate'
                    + ', Load_Request__r.Name'
                    + ', Load_Request__r.Tank_Size__c'
                    + ', Load_Request__r.Status__c'
                    + ', Load_Request__r.Tank_Low_Level__c'
                    + ', Load_Request__r.Act_Tank_Level__c'
                    + ', Load_Request__r.Act_Flow_Rate__c'
                    + ', Load_Request__r.Source_Location__c'
                    + ', Load_Request__r.Source_Facility__c'
                    + ', Load_Request__r.Source_Location__r.Name'
                    + ', Load_Request__r.Source_Facility__r.Name'
                    + ', Load_Request__r.Source_Location__r.Surface_Location__c'
                    + ', Carrier__c'
                    + ', Carrier__r.Name'
                    + ', Carrier__r.Carrier_Name_For_Fluid__c'
                    + ' FROM FM_Truck_Trip__c';

    public static final String  TRUCKTRIP_EXPORT_LINK_BASE = '/apex/FM_TruckTripExportCSV?trucktrips=';

    public static final Integer TRUCKTRIP_IMPORT_TRUCK_TRIP_INDEX = 0;
    public static final Integer TRUCKTRIP_IMPORT_LOAD_REQUEST_INDEX = 1;
    public static final Integer TRUCKTRIP_IMPORT_ROUTE_INDEX = 2;
    public static final Integer TRUCKTRIP_IMPORT_DATE_INDEX = 3;
    public static final Integer TRUCKTRIP_IMPORT_WELL_NAME_INDEX = 4;
    public static final Integer TRUCKTRIP_IMPORT_TANK_SIZE_INDEX = 5;
    public static final Integer TRUCKTRIP_IMPORT_TANK_LOW_INDEX = 6;
    public static final Integer TRUCKTRIP_IMPORT_TANK_LEVEL_INDEX = 7;
    public static final Integer TRUCKTRIP_IMPORT_FLOW_RATE_INDEX = 8;
    public static final Integer TRUCKTRIP_IMPORT_SHIFT_INDEX = 9;
    public static final Integer TRUCKTRIP_IMPORT_PRODUCT_INDEX = 10;
    public static final Integer TRUCKTRIP_IMPORT_COMMENTS_INDEX = 11;
    public static final Integer TRUCKTRIP_IMPORT_UNITCONFIG_INDEX = 12;
    public static final Integer TRUCKTRIP_IMPORT_SOUR_INDEX = 13;
    public static final Integer TRUCKTRIP_IMPORT_SURFACE_LOCATION_INDEX = 14;
    public static final Integer TRUCKTRIP_IMPORT_TICKET_NUM_INDEX = 15;
    public static final Integer TRUCKTRIP_IMPORT_SCALE_TICKET_NUM_INDEX = 16;
    public static final Integer TRUCKTRIP_IMPORT_TRUCK_UNIT_NUM_INDEX = 17;
    public static final Integer TRUCKTRIP_IMPORT_PROD_DATE_INDEX = 18;
    public static final Integer TRUCKTRIP_IMPORT_FROM_LOCATION_INDEX = 19;
    public static final Integer TRUCKTRIP_IMPORT_DESTINATION_INDEX = 20;
    public static final Integer TRUCKTRIP_IMPORT_FLUID_VOL_INDEX = 21;
    public static final Integer TRUCKTRIP_IMPORT_TICKET_PRODUCT_INDEX = 22;
    public static final Integer TRUCKTRIP_IMPORT_TRUCK_CONFIG_INDEX = 23;
    public static final Integer TRUCKTRIP_IMPORT_STUCK_TIME_IN_INDEX = 24;
    public static final Integer TRUCKTRIP_IMPORT_STUCK_TIME_OUT_INDEX = 25;

    //////////////////////////////////////////////////
    //* CONSTANTS -> RUNSHEET DATA & CONFIGURATION *//
    //////////////////////////////////////////////////

    public static final String FACILITY_SAND_CAVERN_NAME = 'Husky Sand Cavern 7-30-49-27W3';
    public static final String FACILITY_DEFAULT_AXLE_VALUE = '6';

    public static final String RUNSHEET_DEFAULT_LOAD_WEIGHT = 'Primary';
    public static final String RUNSHEET_OPERATOR_ON_CALL = 'ooc';
    public static final String RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER = '###_WELL_###';

    public static final Map<String, String> RUNSHEET_UNITCONFIG_MAP = new Map<String, String>{'T6X' => '6', 'T5X' => '5', 'B6X' => 'BJP', 'B3X' => 'BJ'};
    public static final Map<String, Integer[]> RUNSHEET_UNITCONFIG_VOLUME_MAP = new Map<String, Integer[]>{'T6X' => new Integer[]{30,24,19}, 'T5X' => new Integer[]{24,19,14}, 'B6X' => new Integer[]{26,22,17}, 'B3X' => new Integer[]{13,10,8}};

    //Marek 5/12/2016 -> change, added suspended wells
    //public static final String[] RUNSHEET_WELL_INCLUDED_STATUSES = new String[]{'PROD', 'SHUT', 'STND'};
    public static final String[] RUNSHEET_WELL_INCLUDED_STATUSES = new String[]{'PROD', 'SHUT', 'STND','SUSP'};
    public static final String[] RUNSHEET_WELL_TYPES = new String[]{'GAS', 'OIL', 'OIL-HVY'};
    public static final Integer[] RUNSHEET_FUNCTIONAL_LOCATION_CATEGORIES = new Integer[]{4};

    public static final String RUNSHEET_VALUE_NOT_SELECTED = 'na';
    public static final Integer RUNSHEET_SINGLE_RESULT = 1;
    public static final Integer RUNSHEET_NO_RESULT = 0;

    public static final Integer RUNSHEET_EXTRA_UNBOUND_TANKS = 2;

    public static final String RUNSHEET_DATE_FORMAT = 'MMMMM dd yyyy h:mm a';
    public static final String RUNSHEET_DATE_FORMAT_H2S = 'MMMMM dd yyyy';

    //////////////////////
    //* MISC CONSTANTS *//
    //////////////////////

    public static final String DISPATCH_DESK_FLUID_RECORD_TYPE = 'Fluid_Dispatch';

    private static final String LOAD_CHANGE_ERROR_ALREADY_DISPATCHED = 'You cannot change tonight or tomorrow\'s loads because some loads have already been dispatched for';
    
    //////////////////////////////////////////////////////////////////
    // LIST OF TANK LABELS FOR DISPLAYING IN LOAD REQUESTS          //
    // must match values in Equipment_Tanks__c.Tank_Label__c        //
    //////////////////////////////////////////////////////////////////
    public static final List<Map<String, String>> TANK_LABELS = new List<Map<String, String>>{
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 1'},
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 2'},
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 3'},
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 4'},
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 5'},
        new Map<String, String>{'type' => 'location', 'label' => 'Tank 6'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Tank 1'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Test 1'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Test 2'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Water'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Group'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Settling'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Sales'},
        new Map<String, String>{'type' => 'facility', 'label' => 'Skim'}
    };
    // this constant denotes the number of hours since the beginning of the Runsheet when the information is still editable.  This
    // really only affects the Day shift.  The Night shift should be unlocked after midnight, but the Day shift runs from 6am to 6pm
    // and dispatchers may be trying to make some edits before 6am.  If we check strictly by the Date, then all the Day shift records
    // will be locked even though they should still be editable.
    // For example, 10am the following day will be 34 hours since the midnight before.
    // For example, 12noon the following day will be 36 hours since the midnight before.
    // For example, 5pm the following day will be 41 hours since the midnight before.
    // ** UPDATED ON 2015-10-15 BY GM - THIS NOW INDICATES A NUMBER PAST 24 HOURS AS A DEFAULT IN CONJUNCTION WITH A CUSTOM SETTING ** //

    public static final Integer RUNSHEET_EDIT_GRACEPERIOD_IN_HOURS_DEFAULT = 8;
    public static final Integer RUNSHEET_EDIT_GRACEPERIOD_BASELINE_IN_HOURS = 24;

    public static final String[] FACILITY_SUMMARY_STATUS_LIST = new String[]{TRUCKTRIP_STATUS_BOOKED, TRUCKTRIP_STATUS_DISPATCHED, TRUCKTRIP_STATUS_ADDON, TRUCKTRIP_STATUS_COMPLETED};

    /*
      Refactoring the list of dispatchers from FM_TruckListsCustomCtrl to FM_Utilities
      The idea behind this is to ensure that the diaptchers list can be re-used
        LIST OF ALL DISPATCHERS (USERS WITH ROLE 'DISPATCHER' or 'LEAD DISPATCHER')
        originaly it was list of all users with dispatcher permission set, original code commented
    */
    public static List<SelectOption> lDispatchUsersList {
        get{
            if(lDispatchUsersList == null){
                //List<PermissionSetAssignment> lUserList = [SELECT Assignee.Id, Assignee.Name FROM dispatchers WHERE PermissionSet.Name = :FM_Utilities.FLUID_PERMISSION_SET_DISPATCH_STANDARD AND Assignee.IsActive = true AND Assignee.Id != :UserInfo.getUserId() ORDER BY Assignee.Name];
                lDispatchUsersList = new List<SelectOption>();

                //for(PermissionSetAssignment oOneUser : lUserList)
                List<User> dispatchers = [SELECT Id, Name, UserRole.Name
                                          FROM   User
                                          WHERE  UserRole.Name = 'Dispatcher'   OR     UserRole.Name = 'Lead Dispatcher'
                                          Order By Name];

                //Getting list of all users with permission set HOG_FM_Dispatcher
                Set<PermissionSetAssignment> psaList =new Set<PermissionSetAssignment>( [SELECT Assignee.Id, Assignee.Name
                                                           FROM   PermissionSetAssignment
                                                           WHERE  PermissionSet.Name = :FM_Utilities.FLUID_PERMISSION_SET_DISPATCH_STANDARD
                                                                  AND Assignee.IsActive = true]);

                // Here we determine if the user belongs to the permission set, if yes, we add him
                for(User u: dispatchers)
                {
                    for(PermissionSetAssignment permSet : psaList ) {
                        if(permSet.Assignee.Id == u.Id) {
                            lDispatchUsersList.add(new SelectOption(u.Id, u.Name));
                        }
                    }
                }
            }
            System.debug('Final list of users:: ' +lDispatchUsersList);
            return lDispatchUsersList;
        }
        private set;
    }

    public static Map<Id, Carrier__c> carrierMap {
        get {
            if (carrierMap == null)
                carrierMap = new Map<Id, Carrier__c>([SELECT Id, Carrier_Name_For_Fluid__c 
                                                        FROM Carrier__c 
                                                        WHERE Enabled__c = true 
                                                        ORDER BY Carrier_Name_For_Fluid__c ASC]);
            return carrierMap;
        } 
        private set;
    }
    public static Map<Id, Carrier__c> carrierDisabledMap {
        get {
            if (carrierDisabledMap == null)
                carrierDisabledMap = new Map<Id, Carrier__c>([SELECT Id, Carrier_Name_For_Fluid__c 
                                                        FROM Carrier__c
                                                        WHERE Enabled__c = false 
                                                        ORDER BY Carrier_Name_For_Fluid__c ASC]);
            return carrierDisabledMap;
        } 
        private set;
    }
    public static Map<Id, Carrier_Unit__c> unitMap {
        get {
            if (unitMap == null)
                unitMap = new Map<Id, Carrier_Unit__c>([SELECT Id, Name 
                                                        FROM Carrier_Unit__c 
                                                        WHERE Enabled__c = true
                                                        ORDER BY Name ASC]);
            return unitMap;
        } 
        private set;
    }
    public static Map<Id, Carrier_Unit__c> unitDisabledMap {
        get {
            if (unitDisabledMap == null)
                unitDisabledMap = new Map<Id, Carrier_Unit__c>([SELECT Id, Name 
                                                        FROM Carrier_Unit__c 
                                                        WHERE Enabled__c = false 
                                                        ORDER BY Name ASC]);
            return unitDisabledMap;
        } 
        private set;
    }


    /***********************************************************************************************
    * Utility used to execute the Trigger code, value defaults to true
    ***********************************************************************************************/

    public static Boolean executeTriggerCode = true;
    public static Boolean bRecalculateRunsheets = false;

    public static void TriggerBeforeInsertRunSheet(List<FM_Run_Sheet__c> newRecords)
    {
        SendH2SNotifications(newRecords, new Map<Id, FM_Run_Sheet__c>(), true);
    }

    public static void TriggerBeforeUpdateRunSheet(List<FM_Run_Sheet__c> newRecords,  Map<Id, FM_Run_Sheet__c> oldMap)
    {
        // ** IF RECALCULATING RUNSHEET VALUES, DO NOTHING ** //
        if(bRecalculateRunsheets == true)
        {
            return;
        }

        SendH2SNotifications(newRecords, oldMap, false);
    }

    public static void TriggerBeforeInsertTruckTrip(List<FM_Truck_Trip__c> pNewTruckTripList) {
        for(FM_Truck_Trip__c tt : pNewTruckTripList) {
            if(String.isBlank(tt.Shift_Day__c)) {
                tt.Shift_Day__c = (tt.Shift__c == 'Night') ? 'Today' : 'Tomorrow';
            }
        }
    }

    public static void TriggerBeforeUpdateTruckTrip(List<FM_Truck_Trip__c> pNewTruckTripList, Map<Id, FM_Truck_Trip__c> pOldTruckTripMap) {
        ChangeStatusBasedOnRequiredFields(pNewTruckTripList, pOldTruckTripMap);
        SetOwnerOfTruckTrip(pNewTruckTripList, pOldTruckTripMap);
        SetOriginalDestination(pNewTruckTripList, pOldTruckTripMap);
        UpdateRecordType(pNewTruckTripList, pOldTruckTripMap);
        UpdateRunSheetDate(pNewTruckTripList, pOldTruckTripMap);
    }

    public static void UpdateRunSheetDate(List<FM_Truck_Trip__c> pNewTruckTripList, Map<Id, FM_Truck_Trip__c> pOldTruckTripMap) {
        for (FM_Truck_Trip__c tt : pNewTruckTripList) {
            if (tt.Truck_Trip_Status__c == 'Booked' 
                && pOldTruckTripMap.get(tt.Id).Truck_Trip_Status__c == 'Exported') {
                tt.Run_Sheet_Date__c = Date.today();
            }
        }
    }

    public static void TriggerAfterUpdateTruckTrip(List<FM_Truck_Trip__c> newTruckTrips, Map<Id,FM_Truck_Trip__c> oldMap) {
        setLoadRequestStatus(newTruckTrips, oldMap);
        cancelLoadRequestsForCancelledTruckTrips(newTruckTrips, oldMap);
    }

    public static void TriggerAfterInsertEquipment(List<Equipment__c> pNewEquipmentList) {
        Map<Id, Equipment__c> mapLocationToEquipment = new Map<Id, Equipment__c>();
        List<Location__c> lLocations = new List<Location__c>();
        List<Equipment_Tank__c> lEquipmentTanksToInsert = new List<Equipment_Tank__c>();

        //Get Relevant Location Ids for Relevant equipment
        for(Equipment__c oEquipment : pNewEquipmentList) {
            if(oEquipment.Equipment_Category__c == 'D' && oEquipment.Object_Type__c == 'VESS_ATMOS') {
                mapLocationToEquipment.put(oEquipment.Location__c, oEquipment);
                    Equipment_Tank__c newTank = new Equipment_Tank__c(
                    Equipment__c = oEquipment.Id
                );
                lEquipmentTanksToInsert.add(newTank);
            }
        }

        insert lEquipmentTanksToInsert;
    }

    public static void TriggerBeforeInsertStuckTruck(List<FM_Stuck_Truck__c> pNewStuckTrucks) {
        UpdateStuckTruckStatus(pNewStuckTrucks, null);
    }

    public static void TriggerBeforeUpdateStuckTruck(List<FM_Stuck_Truck__c> pNewStuckTrucks, Map<Id, FM_Stuck_Truck__c> pOldStuckTruckMap) {
        UpdateStuckTruckStatus(pNewStuckTrucks, pOldStuckTruckMap);
    }

    private static void UpdateStuckTruckStatus(List<FM_Stuck_Truck__c> pNewStuckTrucks, Map<Id, FM_Stuck_Truck__c> pOldStuckTruckMap) {
        for(FM_Stuck_Truck__c stuckTruck : pNewStuckTrucks) {
            if(stuckTruck.Stuck_To__c != null && (pOldStuckTruckMap == null || pOldStuckTruckMap.get(stuckTruck.Id).Stuck_To__c == null)) {
                stuckTruck.Status__c = STUCK_TRUCK_STATUS_UNSTUCK;
            }
        }
    }

    public static void UpdateCarryoverTruckTripsToToday(List<FM_Truck_Trip__c> carryOverTruckTripList) {
        System.debug('FM_Utilities.UpdateCarryoverTruckTripsToToday');
        for(FM_Truck_Trip__c trip : carryOverTruckTripList) {
            trip.Run_Sheet_Date__c = Date.today();
            System.debug('UpdateCarryoverTruckTripsToToday->Run_Sheet_Date__c: ' + trip.Run_Sheet_Date__c);
        }

        update carryOverTruckTripList;
    }

    /**
     * This will go over booked Truck trips and checks if there is existing booked truck trip with matching TT_Key_String__c
     * If there is we well take TL_First_Booked_By__c from that one making owner of processed Truck trip a owener of existing one
     * If there is no truck trip with TT_Key_String__c it means current user is one that will be a owner of this truck trip and also
     * subsequential truck trips with TT_Key_String__c
     * @param pNewTruckTripList [description]
     * @param pOldTruckTripMap  [description]
     */
    public static void SetOwnerOfTruckTrip(List<FM_Truck_Trip__c> pNewTruckTripList, Map<Id, FM_Truck_Trip__c> pOldTruckTripMap)
    {
        Date startDate, endDate; //attempt to get rid of non-selective query
        //Holds TT_Key_String__c values of booked truck trips
        Set<String> uniqueBookedTruckTripNames = new Set<String>();
        for(FM_Truck_Trip__c tr: pNewTruckTripList){
            if(tr.Truck_Trip_Status__c == TRUCKTRIP_STATUS_BOOKED ) {
                String key = String.valueOf(tr.Run_Sheet_Date__c)+':'+tr.Shift__c+':'+tr.Truck_Trip_Status__c+':'+String.valueOf(tr.Unit__c).substring(0, 15);
                uniqueBookedTruckTripNames.add(key);
                startDate = (startDate == null) ? tr.Run_Sheet_Date__c : (tr.Run_Sheet_Date__c < startDate) ? tr.Run_Sheet_Date__c : startDate;
                endDate = (endDate == null) ? tr.Run_Sheet_Date__c : (tr.Run_Sheet_Date__c > startDate) ? tr.Run_Sheet_Date__c : startDate;
            }
        }
        //Populates map with TT_Key_String__c as a key and list of existing truck trips with this TT_Key_String__c
        List<FM_Truck_Trip__c> existingBookedTruckTrips = new List<FM_Truck_Trip__c>();
        Map<String, List<FM_Truck_Trip__c>> uniqueNewFieldTruckTripMap = new Map<String, List<FM_Truck_Trip__c>>();
        if(uniqueBookedTruckTripNames.size() > 0){
            existingBookedTruckTrips = [SELECT id,
                                                TL_First_Booked_By__c,
                                                TT_Key_String__c,
                                                Truck_Trip_Status__c
                                       FROM FM_Truck_Trip__c
                                       WHERE TT_Key_String__c IN :uniqueBookedTruckTripNames
                                       And Run_Sheet_Date__c >= :startDate
                                       And Run_Sheet_Date__c <= :endDate];

            for(FM_Truck_Trip__c trip: existingBookedTruckTrips){
                System.debug('Adding key ' + trip.TT_Key_String__c);
                if(uniqueNewFieldTruckTripMap.containsKey(trip.TT_Key_String__c)){
                    List<FM_Truck_Trip__c> trList = uniqueNewFieldTruckTripMap.get(trip.TT_Key_String__c);
                    trList.add(trip);
                    uniqueNewFieldTruckTripMap.put(trip.TT_Key_String__c, trList);
                } else {
                    List<FM_Truck_Trip__c> newList = new List<FM_Truck_Trip__c>();
                    newList.add(trip);
                    uniqueNewFieldTruckTripMap.put(trip.TT_Key_String__c, newList);
                }
            }

        }

        //This checks if there are existing Truck trips with TT_Key_String__c sets owner

        for(FM_Truck_Trip__c tr: pNewTruckTripList){

            if(tr.Truck_Trip_Status__c == TRUCKTRIP_STATUS_BOOKED){
                String key = String.valueOf(tr.Run_Sheet_Date__c)+':'+tr.Shift__c+':'+tr.Truck_Trip_Status__c+':'+String.valueOf(tr.Unit__c).substring(0, 15);
                System.debug('Checking for a key ' + key);
                if(uniqueNewFieldTruckTripMap.containsKey(key) ){

                    List<FM_Truck_Trip__c> trList = uniqueNewFieldTruckTripMap.get(key);
                    if(!trList.isEmpty()){
                        tr.TL_First_Booked_By__c = trList[0].TL_First_Booked_By__c;
                        System.debug('FOUND Truck trip with TT_Key_String__c setting TL_First_Booked_By__c to ' + trList[0].TL_First_Booked_By__c);
                    }
                } else {

                    tr.TL_First_Booked_By__c = UserInfo.getUserId();
                    System.debug('Havent found Truck trip with TT_Key_String__c setting TL_First_Booked_By__c to ' + UserInfo.getUserId());
                }
            }
        }

    }

    public static void SetOriginalDestination(List<FM_Truck_Trip__c> pNewTruckTripList, Map<Id, FM_Truck_Trip__c> pOldTruckTripMap) {
        for(FM_Truck_Trip__c tt: pNewTruckTripList) {

            if (tt.Truck_Trip_Status__c == TRUCKLIST_STATUS_DISPATCHED && !pOldTruckTripMap.get(tt.Id).Is_Reroute__c) {
                if (tt.Facility_Lookup__c != pOldTruckTripMap.get(tt.Id).Facility_Lookup__c) {
                    tt.Facility_Lookup_Original__c = pOldTruckTripMap.get(tt.Id).Facility_Lookup__c;
                    tt.Is_Reroute__c = true;
                }
                if (tt.Well__c != pOldTruckTripMap.get(tt.Id).Well__c) {
                    tt.Well_Lookup_Original__c = pOldTruckTripMap.get(tt.Id).Well__c;
                    tt.Is_Reroute__c = true;
                }
            }
        }
    }

    private static Boolean CanEditGivenBackInTruckTrips(FM_Truck_Trip__c pNewTruckTrip, FM_Truck_Trip__c pOldTruckTrip) {
        // TruckTrip.Stuck__c is a Roll-up summary field summing count of Stuck_Truck__c
        // with creating new StuckTruck record, the parent TruckTrip gets recalculated thus triggers are fired
        // thus change of TruckTrip in GivenBack status is needed
        // i.e. Error is added when TT.Status is GivenBack and there are no StuckTrucks created yet
        if(pOldTruckTrip.Truck_Trip_Status__c == TRUCKTRIP_STATUS_GIVENBACK && pOldTruckTrip.Stuck__c == 0) {
            pNewTruckTrip.addError(' Cannot edit truck trips in ' + TRUCKLIST_STATUS_GIVENBACK + ' status.');
            return false;
        }
        return true;
    }

    private static void ChangeStatusBasedOnRequiredFields(List<FM_Truck_Trip__c> pNewTruckTripList, Map<Id, FM_Truck_Trip__c> pOldTruckTripMap) {

        // this routine is only applicable for truck trips that don't have a status change, and they are previously not
        // Cancelled or Carryover.
        // If user enters every required field but set status to Cancelled, then Cancelled takes precedence.
        // if user enters every required field while status was set to Cancelled, then status changes to Booked.
        // Note that this routine is only for non-dispatched loads.
        for (FM_Truck_Trip__c truckTrip : pNewTruckTripList)
        {
            System.debug(truckTrip.Truck_Trip_Status__c);
            // disable changes on truck trip in GivenBack status
            // but allow changes if there is StuckTruck
            if(!CanEditGivenBackInTruckTrips(truckTrip, pOldTruckTripMap.get(truckTrip.Id))) 
                continue;
            if ((truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_DISPATCHED) &&
                (truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_COMPLETED) &&
                (truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_ADDON) &&
                (truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_CANCELLED) &&
                (truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_GIVENBACK) &&
                (truckTrip.Truck_Trip_Status__c == pOldTruckTripMap.get(truckTrip.Id).Truck_Trip_Status__c))
            {
                if (((truckTrip.Facility_Type__c == 'Facility' && truckTrip.Facility_Lookup__c != null) ||
                     (truckTrip.Facility_Type__c == 'Location' && truckTrip.Location_Lookup__c != null)) &&
                    truckTrip.Carrier__c != null && truckTrip.Unit__c != null && truckTrip.Shift__c != null)
                {
                    System.debug('NEWSTATUS: ' + truckTrip.Truck_Trip_Status__c);
                    System.debug('OLDSTATUS: ' + pOldTruckTripMap.get(truckTrip.Id).Truck_Trip_Status__c);
                    truckTrip.Truck_Trip_Status__c = TRUCKTRIP_STATUS_BOOKED;
                    //if(truckTrip.Shift__c == 'Night') truckTrip.Shift_Day__c = 'Today';
                    //else if (truckTrip.Shift__c == 'Day') truckTrip.Shift_Day__c = 'Tomorrow';
                }
                // if previously the status is Cancelled or Carryover, status don't change.  Only change status is
                // previously it was not Cancelled or Carryover.
                // And don't change status to new for exported ad redispatch
                else{
                    if (pOldTruckTripMap.get(truckTrip.Id).Truck_Trip_Status__c != TRUCKTRIP_STATUS_CANCELLED &&
                        pOldTruckTripMap.get(truckTrip.Id).Truck_Trip_Status__c != TRUCKTRIP_STATUS_CARRYOVER &&
                        truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_EXPORTED &&
                        truckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_REDISPATCH)
                    {
                        truckTrip.Truck_Trip_Status__c = TRUCKTRIP_STATUS_NEW;
                    }
                }
            }
            // if previously the status is new and the new status is cancelled or carryover, change the status to
            // cancelled and remove the unit
            if ((truckTrip.Truck_Trip_Status__c == TRUCKTRIP_STATUS_CANCELLED || truckTrip.Truck_Trip_Status__c == TRUCKTRIP_STATUS_CARRYOVER) &&
                (truckTrip.Truck_Trip_Status__c != pOldTruckTripMap.get(truckTrip.Id).Truck_Trip_Status__c))
            {
                truckTrip.Facility_Lookup__c    = null;
                truckTrip.Location_Lookup__c    = null;
                truckTrip.Facility_Type__c      = null;
                truckTrip.Unit__c               = null;
                truckTrip.Well__c               = null;

                if (truckTrip.Truck_Trip_Status__c == TRUCKTRIP_STATUS_CARRYOVER && truckTrip.Run_Sheet_Date__c < Date.today()) {
                    truckTrip.Run_Sheet_Date__c = Date.today();
                }
            }
            System.debug(truckTrip.Truck_Trip_Status__c);

        }
    }

    private static void UpdateRecordType(List<FM_Truck_Trip__c> truckTripList, Map<Id, FM_Truck_Trip__c> oldMap) {


        List<RecordType> truckTripRecordTypes = [Select Id From RecordType Where SObjectType = 'FM_Truck_Trip__c' Order By DeveloperName];


        for(FM_Truck_Trip__c tt : truckTripList) {
            if(tt.Stuck__c > 0 && oldMap.get(tt.Id).Stuck__c == 0) {
                System.debug('TruckTrip->stuck: ' + tt.Name);
                tt.RecordTypeId = truckTripRecordTypes[0].Id;
            } else if (tt.Stuck__c == 0 && oldMap.get(tt.Id).Stuck__c > 0) {
                System.debug('TruckTrip->unstuck: ' + tt.Name);
                tt.RecordTypeId = truckTripRecordTypes[1].Id;
            }
        }
    }

    private static void cancelLoadRequestsForCancelledTruckTrips(List<FM_Truck_Trip__c> truckTripList,
        Map<Id, FM_Truck_Trip__c> oldMap) {
        Map<String, String> loadRequestsMap = new Map<String, String>();
        Map<String, String> loadRequestCancelMap = new Map<String, String>();
        List<FM_Load_Request__c> loadRequestList = new List<FM_Load_Request__c>();
        List<FM_Truck_Trip__c> actionableCancelledTruckTrips = new List<FM_Truck_Trip__c>();
        System.debug('Cancel Load Requests For Cancelled Truck Trips');
        for (FM_Truck_Trip__c newTt : truckTripList) {
            if (newTt.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_CANCELLED &&
                oldMap.get(newTt.Id).Truck_Trip_Status__c <> FM_Utilities.TRUCKTRIP_STATUS_CANCELLED) {
                System.debug('Canceling LR');
                loadRequestsMap.put(newTt.Load_Request__c, newTt.Load_Request_Cancel_Reason__c);
                loadRequestCancelMap.put(newTt.Load_Request__c, newTt.Load_Request_Cancel_Comments__c);
                actionableCancelledTruckTrips.add(newTt); //For error handling
            }
        }

        loadRequestList = [SELECT Id, Cancel_Reason__c
                            FROM FM_Load_Request__c
                            WHERE Id IN : loadRequestsMap.keySet()];
        for (FM_Load_Request__c loadRequest : loadRequestList) {
            loadRequest.Cancel_Reason__c = loadRequestsMap.get(loadRequest.Id);
            loadRequest.Cancel_Comments__c = loadRequestCancelMap.get(loadRequest.Id);
            loadRequest.Status__c = FM_LoadRequest_Utilities.LOADREQUEST_STATUS_CANCELLED;
        }
        System.debug('List of LoadRequests:' + loadRequestList);

        List<Database.SaveResult> saveResults = Database.update(loadRequestList, false);
        for(Integer i=0; i < saveResults.size(); i++) {
            Database.SaveResult result = saveResults[i];
            if(!result.isSuccess()) {
                String errorMessage = '';
                for(Database.Error error : result.getErrors()) {
                    errorMessage += error.getMessage() + '\n';
                }
                actionableCancelledTruckTrips[i].addError(errorMessage);
            }
        }
    }

    private static void setLoadRequestStatus(List<FM_Truck_Trip__c> truckTripList,
                                             Map<Id, FM_Truck_Trip__c> oldMap) {
        Map<Id,FM_Load_Request__c> loadRequestMap = new Map<Id, FM_Load_Request__c>();
        Set<Id> loadRequestIds = new Set<Id>();
        System.debug('Set Load Request Status');
        for (FM_Truck_Trip__c newTT : truckTripList) {
            System.debug(newTT.Truck_Trip_Status__c);
            if ((newTT.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_COMPLETED
                && oldMap.get(newTT.Id).Truck_Trip_Status__c != FM_Utilities.TRUCKTRIP_STATUS_COMPLETED) ||
                (newTT.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_EXPORTED
                && oldMap.get(newTT.Id).Truck_Trip_Status__c != FM_Utilities.TRUCKTRIP_STATUS_EXPORTED) ||
                (newTT.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_BOOKED
                && oldMap.get(newTT.Id).Truck_Trip_Status__c != FM_Utilities.TRUCKTRIP_STATUS_BOOKED) ||
                (newTT.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED
                && oldMap.get(newTT.Id).Truck_Trip_Status__c != FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED) ||
                (newTT.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_ADDON
                && oldMap.get(newTT.Id).Truck_Trip_Status__c != FM_Utilities.TRUCKTRIP_STATUS_ADDON)) {
                loadRequestIds.add(newTT.Load_Request__c);
                loadRequestMap.put(newTT.Load_Request__c, new FM_Load_Request__c(id = newTT.Load_Request__c,
                    Status__c = getUpdatedLoadRequestStatus(newTT.Truck_Trip_Status__c)));
            }
            System.debug(newTT.Truck_Trip_Status__c);
        }

        //Update Ticket Number on LRs
        for(FM_Load_Confirmation__c loadConfirmation : [Select Id, Name, Ticket_Number__c, Truck_Trip__r.Load_Request__c
                                                        From FM_Load_Confirmation__c
                                                        Where Truck_Trip__r.Load_Request__c In :loadRequestIds]) {
            loadRequestMap.get(loadConfirmation.Truck_Trip__r.Load_Request__c).Ticket_Number__c = loadConfirmation.Ticket_Number__c;
        }

        System.debug('LoadRequestMap: ' + loadRequestMap);
        update loadRequestMap.values();
    }

    private static String getUpdatedLoadRequestStatus(String truckTripStatus) {
        return (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_COMPLETED) ? FM_LoadRequest_Utilities.LOADREQUEST_STATUS_HAULED :
            (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_EXPORTED) ? FM_LoadRequest_Utilities.LOADREQUEST_STATUS_EXPORTED :
            (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_BOOKED) ? FM_LoadRequest_Utilities.LOADREQUEST_STATUS_BOOKED :
            (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED || truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_ADDON) ? 
            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_DISPATCHED :
            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_SUBMITTED;
    }

    private static List<PermissionSetAssignment> currentUserPermissionSetList {
        get {
            if(currentUserPermissionSetList == null || currentUserPermissionSetList.isEmpty()) {
                currentUserPermissionSetList = [SELECT Id, PermissionSet.Name,AssigneeId
                                                FROM PermissionSetAssignment
                                                WHERE AssigneeId = :Userinfo.getUserId()];
            }
            return currentUserPermissionSetList;
        }
        set;
    }

    //check if user is dispatcher
    public static Boolean IsDispatcher() {
        for (PermissionSetAssignment psa: currentUserPermissionSetList){
            if(psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_DISPATCH_STANDARD)
                || psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_DISPATCH_VENDOR)
                || psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_FLUID_ADMIN))
            {
                return true;
            }
        }
        return false;
    }

    public static Boolean IsInternalDispatcher() {
        for (PermissionSetAssignment psa: currentUserPermissionSetList){
            if(psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_DISPATCH_STANDARD)
                || psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_FLUID_ADMIN))
            {
                return true;
            }
        }
        return false;
    }

    public static Boolean IsVendorDispatcher() {
        for (PermissionSetAssignment psa: currentUserPermissionSetList){
            if(psa.PermissionSet.Name.equals(FLUID_PERMISSION_SET_DISPATCH_VENDOR))
            {
                return true;
            }
        }
        return false;
    }

    public static void logError(Exception ex) {
            System.debug('ERRR:' + ex);
        string message = ex.getMessage();
        logError('Unexpected error:' +message );
    }

    public static void logError(string errorMessage)
    {
        String message = errorMessage;
        system.debug(message);
        ApexPages.addMessage(new ApexPages.Message(ApexPages.severity.ERROR, message));
    }

    public static void logWarning(Exception ex)
    {
        logWarning('Unexpected error: ' + ex.getMessage());
    }

    public static void logWarning(String errorMessage)
    {
        System.debug('Log Warning: ' + errorMessage);
        ApexPages.addMessage(new ApexPages.Message(ApexPages.severity.WARNING, errorMessage));
    }

    public static void SendH2SNotifications(List<FM_Run_Sheet__c> newRecords,  Map<Id, FM_Run_Sheet__c> oldMap, Boolean isBefore)
    {
        system.debug('Executing SendH2SNotifications...');

        Set<Id> LocationIds = new Set<Id>();
        Set<ID> H2SLocationIDs = new Set<ID>();

        for (FM_Run_Sheet__c runsheet :newRecords)
        {
            LocationIds.add(runsheet.Well__c);
        }

        Map<Id, Location__c> locationMap = new Map<Id, Location__c>([
            select Name, Hazardous_H2S__c,
                Route__r.Field_Senior__c, Route__r.Field_Senior__r.email,
                Operating_Field_AMU__r.Operating_District__r.Operations_Coordinator_User__r.email
            from Location__c where Id in :LocationIds
            ]);

        system.debug('locationMap:'+locationMap);

        for (FM_Run_Sheet__c runsheet :newRecords)
        {

            Location__c well = locationMap.get(runsheet.Well__c);
            if(runsheet.Facility__c == null && well == null)
            {
                runsheet.addError('Unknown Well Location for runsheet ID:' + runsheet.id);
            }
            else if(runsheet.Facility__c == null)
            {
                // ** ONLY PROCESS RUNSHEETS WITH A BLANK FACILITY ** //

                Boolean processRunSheet = true;
                if(oldMap <> null)
                {
                    FM_Run_Sheet__c oldRunSheet = oldMap.get(runsheet.Id);
                    if(oldRunSheet <> null && runsheet.Sour__c == oldRunSheet.Sour__c)
                    {
                        processRunSheet = false;
                    }
                }

                //location was marked as sour in Runsheet but not in SAP
                if(runsheet.Sour__c && well.Hazardous_H2S__c <> 'Y' && processRunSheet)
                {
                    H2SLocationIDs.add(well.Id);
                }
            }
        }

        system.debug('H2SLocationIDs:'+H2SLocationIDs);

        Messaging.SingleEmailMessage[] emailList =  new Messaging.SingleEmailMessage[] {};
        for(ID locationId : H2SLocationIDs)
        {
            Location__c well = locationMap.get(locationId);

            system.debug('H2SLocation:'+well);
            system.debug('well.Route__r.Field_Senior__c:'+well.Route__r.Field_Senior__c);
            system.debug('well.Route__r.Field_Senior__r.email:'+well.Route__r.Field_Senior__r.email);

            if(well <> null && well.Route__r.Field_Senior__c <> null && well.Route__r.Field_Senior__r.email <> null)
            {
                Messaging.SingleEmailMessage mail = new Messaging.SingleEmailMessage();
                String emailAddr = well.Route__r.Field_Senior__r.Email;

                String operatingCoordinatorEmail = null;
                try{
                    operatingCoordinatorEmail = well.Operating_Field_AMU__r.Operating_District__r.Operations_Coordinator_User__r.email;
                } catch(Exception ex) {
                    system.debug('FM_Utilities.SendH2SNotifications error - operatingCoordinatorEmail is null');
                }

                String[] toAddresses = new String[] {emailAddr};
                if(operatingCoordinatorEmail <> null)
                {
                    toAddresses.add(operatingCoordinatorEmail);
                }


                mail.setToAddresses(toAddresses);
                mail.setSubject('H2S Status Change Notification: ' + well.Name );

                String plainBody = 'The H2S status for this location ' + well.Name  + ' has been requested for change by ' + Userinfo.getName()
                + '\nPlease confirm this status change and have SAP updated immediately to reflect the current state of H2S for this location.';
                String htmlBody = 'The H2S status for this location <b>' + well.Name  + '</b> has been requested for change by ' + Userinfo.getName()
                + '<br/>Please confirm this status change and have SAP updated immediately to reflect the current state of H2S for this location.';

                mail.setPlainTextBody(plainBody);
                mail.setHtmlBody(htmlBody);

                //The H2S status for this location has been requested for change by “USER”. {USER will be the operator that requested the H2S change}
                //Please confirm this status change and have SAP updated immediately to reflect the current state of H2S for this location.

                emailList.add(mail);
            }
        }

        SendEmail(emailList);
    }

    private static void SendEmail(Messaging.SingleEmailMessage[] emailList)
    {
        Messaging.sendEmail(emailList);
    }

    public static List<SelectOption> GetTruckTripStatusPicklistForEntry() {
        List<SelectOption> truckTripStatusList = new List<SelectOption>();

        Schema.DescribeFieldResult fieldResult = FM_Truck_Trip__c.Truck_Trip_Status__c.getDescribe();
        List<Schema.PicklistEntry> ple = fieldResult.getPicklistValues();

        for(Schema.PicklistEntry f : ple) {
            // exclude Dispatched status from the picklist - Dispatched is a system status - governed by the parent truck list
            if (f.getValue() != TRUCKTRIP_STATUS_DISPATCHED){
                // Users can only select Carryover and Cancelled, i.e. New and Booked are locked.
                SelectOption option = new SelectOption(f.getLabel(), f.getValue());
                if(    f.getValue() == TRUCKTRIP_STATUS_NEW
                    || f.getValue() == TRUCKTRIP_STATUS_BOOKED
                    || f.getValue() == TRUCKLIST_STATUS_GIVENBACK 
                    || f.getValue() == TRUCKTRIP_STATUS_REDISPATCH
                    || f.getValue() ==  TRUCKTRIP_STATUS_EXPORTED 
                    || f.getValue() ==  TRUCKTRIP_STATUS_COMPLETED
                    || f.getValue() ==  TRUCKTRIP_STATUS_UNCANCELLED
                    || f.getValue() == TRUCKTRIP_STATUS_ADDON) {
                    option.setDisabled(true);
                }
                truckTripStatusList.add(option);
            }
        }
        return truckTripStatusList;
    }

    public static Map<String, Facility__c> fluidDestinationFacilitiesMap {
        get {
            if (fluidDestinationFacilitiesMap == null) {
                fluidDestinationFacilitiesMap = new Map<String, Facility__c>();
                for(Facility__c facility :  [Select Id, Name, Facility_Name_For_Fluid__c
                                             From Facility__c
                                             Where Fluid_Facility_Ind__c = true]) {
                    fluidDestinationFacilitiesMap.put(facility.Id, facility);
                }
            }
            return fluidDestinationFacilitiesMap;
        }
        set;
    }

    public static Map<String, Location__c> fluidDestinationLocationsMap {
        get {
            if (fluidDestinationLocationsMap == null) {
                fluidDestinationLocationsMap = new Map<String, Location__c>();
                for(Location__c location : [Select Id, Name, Location_Name_For_Fluid__c
                                            From Location__c
                                            Where Fluid_Location_Ind__c = true]) {
                    fluidDestinationLocationsMap.put(location.Id, location);
                }
            }
            return fluidDestinationLocationsMap;
        }
        set;
    }

    public static Map<String, FM_DestinationFavorites__c> destinationFavoritesMap {
        get {
            if(destinationFavoritesMap == null) {
                destinationFavoritesMap = new Map<String, FM_DestinationFavorites__c>();
                //Create Map
                List<FM_DestinationFavorites__c> destinationFavorites = [Select Id, Name, DestinationIDList__c, Facility__c, Well_Location__c
                                                                         From FM_DestinationFavorites__c];
                for(FM_DestinationFavorites__c favorite : destinationFavorites) {
                    destinationFavoritesMap.put((favorite.Facility__c != null) ? favorite.Facility__c : favorite.Well_Location__c, favorite);
                }
            }
            return destinationFavoritesMap;
        }
        set;
    }

    public static Map<String, Map<String, List<SelectOption>>> dispatchDestinationMap {
        get {
            if(dispatchDestinationMap == null) {
                dispatchDestinationMap = new Map<String, Map<String, List<SelectOption>>>();

                //Go through all the destinationFavoritesMap
                for(String sourceLocationId : destinationFavoritesMap.keySet()) {

                    FM_DestinationFavorites__c destinationFavorites = destinationFavoritesMap.get(sourceLocationId);

                    Set<String> favoriteDestinationIds = new Set<String>();
                    String destinationIDListText = (!String.isEmpty(destinationFavorites.DestinationIDList__c)) ? destinationFavorites.DestinationIDList__c : '';

                    favoriteDestinationIds.addAll(destinationIDListText.split(','));

                    List<SelectOption> favoriteDestinations = new List<SelectOption>();
                    List<SelectOption> allDestinations = new List<SelectOption>();

                    //Create Favorites Map
                    for(String destinationId : favoriteDestinationIds) {
                        Facility__c facility = fluidDestinationFacilitiesMap.get(destinationId);
                        Location__c location = fluidDestinationLocationsMap.get(destinationId);
                        SelectOption option;

                        if(facility != null) {
                            option = new SelectOption(facility.Id + '|Facility|' + ((facility.Facility_Name_For_Fluid__c == null) ? facility.Name : facility.Facility_Name_For_Fluid__c),
                                (facility.Facility_Name_For_Fluid__c == null) ? facility.Name : facility.Facility_Name_For_Fluid__c);
                            favoriteDestinations.add(option);
                        } else if (location != null) {
                            option = new SelectOption(location.Id + '|Location|' + ((location.Location_Name_For_Fluid__c == null) ? location.Name : location.Location_Name_For_Fluid__c),
                                (location.Location_Name_For_Fluid__c == null) ? location.Name : location.Location_Name_For_Fluid__c);
                            favoriteDestinations.add(option);
                        }
                    }

                    //Create All Map
                    for(Facility__c facility : fluidDestinationFacilitiesMap.values()) {
                        if(!favoriteDestinationIds.contains(facility.Id)) {
                            SelectOption option = new SelectOption(facility.Id + '|Facility|' + facility.Facility_Name_For_Fluid__c,
                                (facility.Facility_Name_For_Fluid__c == null) ? facility.Name : facility.Facility_Name_For_Fluid__c);
                            allDestinations.add(option);
                        }
                    }

                    for(Location__c location : fluidDestinationLocationsMap.values()) {
                        if(!favoriteDestinationIds.contains(location.Id)) {
                            SelectOption option = new SelectOption(location.Id + '|Location|' + location.Location_Name_For_Fluid__c,
                                (location.Location_Name_For_Fluid__c == null) ? location.Name : location.Location_Name_For_Fluid__c);
                            allDestinations.add(option);
                        }
                    }


                    Map<String,List<SelectOption>> categorizedDestinationMap = new Map<String,List<SelectOption>>();
                    categorizedDestinationMap.put(DESTINATION_INDEX_FAVORITE_DESTINATIONS, favoriteDestinations);
                    allDestinations = SortSelectOptions(allDestinations, SortSelectOptionBy.Label);

                    categorizedDestinationMap.put(DESTINATION_INDEX_ALL_DESTINATIONS, allDestinations);
                    dispatchDestinationMap.put(sourceLocationId, categorizedDestinationMap);
                }
            }
            return dispatchDestinationMap;
        }
        set;
    }

    public static List<SelectOption> allDestinationOptions {
        get {
            if(allDestinationOptions == null) {
                allDestinationOptions = new List<SelectOption>();

                //Create All Map
                for(Facility__c facility : fluidDestinationFacilitiesMap.values()) {
                    SelectOption option = new SelectOption(facility.Id + '|Facility|' + facility.Facility_Name_For_Fluid__c,
                        (facility.Facility_Name_For_Fluid__c == null) ? facility.Name : facility.Facility_Name_For_Fluid__c);
                    allDestinationOptions.add(option);
                }

                for(Location__c location : fluidDestinationLocationsMap.values()) {
                    SelectOption option = new SelectOption(location.Id + '|Location|' + location.Location_Name_For_Fluid__c,
                        (location.Location_Name_For_Fluid__c == null) ? location.Name : location.Location_Name_For_Fluid__c);
                    allDestinationOptions.add(option);
                }
            }

            allDestinationOptions = SortSelectOptions(allDestinationOptions, SortSelectOptionBy.Label);

            return allDestinationOptions;
        }
        set;
    }

    public static List<SelectOption> facilityPickList
    {
        get
        {
            if(facilityPickList == null)
            {
                facilityPickList = new List<SelectOption>();
                for (Facility__c facility : [SELECT Name, Facility_Name_For_Fluid__c FROM Facility__c WHERE Fluid_Facility_Ind__c = true])
                {
                    facilityPickList.add(new SelectOption(facility.Id + '|Facility|' + facility.Facility_Name_For_Fluid__c, (facility.Facility_Name_For_Fluid__c == null) ? facility.Name : facility.Facility_Name_For_Fluid__c));
                }
                for (Location__c location : [SELECT Name, Location_Name_For_Fluid__c FROM Location__c WHERE Fluid_Location_Ind__c = true])
                {
                    facilityPickList.add(new SelectOption(location.Id + '|Location|' + location.Location_Name_For_Fluid__c, (location.Location_Name_For_Fluid__c == null) ? location.Name : location.Location_Name_For_Fluid__c));
                }

                // Now the two lists are combined.  We need to sort that by the value.  Can override the original select options with the sorted select options.

                facilityPickList = SortSelectOptions(facilityPickList, SortSelectOptionBy.Label);
            }
            return facilityPickList;
        }
        set;
    }

    public static Map<Id, String> facilityMap
    {
        get
        {
            if (facilityMap == null)
            {
                facilityMap = new Map<Id, String>();
                for (SelectOption facility : facilityPickList)
                {
                    facilityMap.put(facility.getValue().split('\\|')[0], facility.getValue().split('\\|')[2]);
                }
            }
            return facilityMap;
        }
        set;
    }

    public static Map<Id, List<Carrier_Unit__c>> carrierUnitMap
    {
        get
        {
            if (carrierUnitMap == null)
            {
                carrierUnitMap = new Map<Id, List<Carrier_Unit__c>>();

                for (Carrier__c carrier : [SELECT (SELECT Name, Enabled__c FROM Carrier_Units__r WHERE RecordType.DeveloperName = 'Fluid_Carrier'
                                            ORDER BY Name)
                                            FROM Carrier__c])
                {
                    for (List<Carrier_Unit__c> unit : carrier.Carrier_Units__r)
                    {
                        carrierUnitMap.put(carrier.Id, unit);
                    }
                }
            }
            return carrierUnitMap;
        }
        set;
    }

    public enum SortSelectOptionBy
    {
        Value,
        Label
    }

    public static List<SelectOption> SortSelectOptions(List<SelectOption> pSelectOptionList, SortSelectOptionBy pSortOption)
    {
        Map<String, SelectOption> stringSelectOptionMap = new Map<String, SelectOption>();
        // use an index to ensure there is no duplicate in the Map's keyset.
        Integer index = 0;

        for (SelectOption so : pSelectOptionList)
        {
            if (pSortOption ==  SortSelectOptionBy.Value)
            {
                stringSelectOptionMap.put(so.getValue() + index++, so);
            }
            else
            {
                stringSelectOptionMap.put(so.getLabel()+ index++, so);
            }
        }

        // Now the map has been built, sort the keySet of the map using a basic List
        List<String> sortedKeyList = new List<String>();
        sortedKeyList.addAll(stringSelectOptionMap.keySet());
        sortedKeyList.sort();

        // now that data has been sorted, place the sorted results into a selectoption and return it.
        List<SelectOption> sortedSelectOption = new LIst<SelectOption>();

        for (String sortedKey : sortedKeyList)
        {
            sortedSelectOption.add(stringSelectOptionMap.get(sortedKey));
        }

        return sortedSelectOption;
    }

    public static List<SelectOption> GenerateSelectOptions(Schema.DescribeFieldResult pFieldResult)
    {
        List<SelectOption> options = new List<SelectOption>();

        // add the remaining values to the picklist
        for (Schema.PicklistEntry plEntry : pFieldResult.getPicklistValues())
        {
            options.add(new SelectOption(plEntry.getValue(), plEntry.getLabel()));
        }
        return options;
    }

    public static List<SelectOption> GenerateShiftSelectOptions() {
        List<SelectOption> shiftSelectOptionList = new List<SelectOption>();

        for(String label : FM_Utilities.dispatchShiftOptionValues.keySet()) {
            if(label == FM_Utilities.DISPATCH_SHIFT_DAY_TODAY) shiftSelectOptionList.add(new SelectOption(FM_Utilities.dispatchShiftOptionValues.get(label), label, isPastDayShiftCutoff()));
            else if(label == FM_Utilities.DISPATCH_SHIFT_TONIGHT_YESTERDAY) shiftSelectOptionList.add(new SelectOption(FM_Utilities.dispatchShiftOptionValues.get(label), label, isPastYesterdayNightShiftCutoff()));
            else shiftSelectOptionList.add(new SelectOption(FM_Utilities.dispatchShiftOptionValues.get(label), label, false));
        }

        return shiftSelectOptionList;
    }

    public static Boolean isPastDayShiftCutoff() {
        String cutOffTimeSetting = HOG_Settings__c.getInstance().Fluid_Day_Dispatch_Cutoff_Hour__c;
        cutOffTimeSetting = String.isBlank(cutOffTimeSetting) ? DAY_DISPATCH_CUTOFF_HOUR : cutOffTimeSetting;
        Time dayTruckListDispatchCutoffTime = Time.newInstance(Integer.valueOf(cutOffTimeSetting.split(':')[0]), Integer.valueOf(cutOffTimeSetting.split(':')[1]), 0, 0);
        return System.now().time() >= dayTruckListDispatchCutoffTime;
    }

    public static Boolean isPastYesterdayNightShiftCutoff() {
        String cutOffTimeSetting =  HOG_Settings__c.getInstance().Fluid_Night_Dispatch_Cutoff_Hour__c;
        cutOffTimeSetting = String.isBlank(cutOffTimeSetting) ? NIGHT_DISPATCH_CUTOFF_HOUR : cutOffTimeSetting;
        Time yesterdayNightTruckListDispatchCutoffTime = Time.newInstance(Integer.valueOf(cutOffTimeSetting.split(':')[0]), Integer.valueOf(cutOffTimeSetting.split(':')[1]), 0, 0);
        return System.now().time() >= yesterdayNightTruckListDispatchCutoffTime;
    }

    public static Boolean canEditTruckList(Date pRunSheetDate)
    {
        // check whether the dispatcher can edit the truck list information.
        // If run sheet date is today, then yes.
        // If run sheet date is yesterday, then the Night load is not editable.  Day load is editable if it is before 6am today.

        HOG_Settings__c oSettings = HOG_Settings__c.getInstance();
        Integer iHours = RUNSHEET_EDIT_GRACEPERIOD_BASELINE_IN_HOURS;

        iHours += (oSettings.Fluid_Day_Shift_Grace_Period_Hours__c == null || oSettings.Fluid_Day_Shift_Grace_Period_Hours__c <= 0) ? RUNSHEET_EDIT_GRACEPERIOD_IN_HOURS_DEFAULT : Integer.valueOf(oSettings.Fluid_Day_Shift_Grace_Period_Hours__c);

        Datetime runSheetGracePeriodEndTime = DateTime.newInstanceGMT(pRunSheetDate.year(), pRunSheetDate.month(), pRunSheetDate.day()).addHours(iHours);
        Integer timeZoneOffset = UserInfo.getTimeZone().getOffset(datetime.now()) / 1000 / 60 / 60;
        Datetime currentDateTimeLocal = Datetime.now().addHours(timeZoneOffset);
        return (runSheetGracePeriodEndTime > currentDateTimeLocal);
    }

    public static String getHaulDate(String pShift, String pShiftDay, Date pRunSheetDate)
    {
        String haulDate;

        if ((pShift == 'Night') || (pShift == '') || (pShift == null))
        {
            haulDate = pRunSheetDate.Year() + '-';
            haulDate += ('0' + pRunSheetDate.Month()).right(2) + '-';
            haulDate += ('0' + pRunSheetDate.Day()).right(2);
        } else if (pShift == 'Day' && pShiftDay == 'Today') {
            haulDate = pRunSheetDate.Year() + '-';
            haulDate += ('0' + pRunSheetDate.Month()).right(2) + '-';
            haulDate += ('0' + pRunSheetDate.Day()).right(2);
        } else if (pShift == 'Day' && (pShiftDay == 'Tomorrow' || pShiftDay == '' || pShiftDay == null)) {
            Date runSheetDatePlus1 = pRunSheetDate.addDays(1);
            haulDate = runSheetDatePlus1.Year() + '-';
            haulDate += ('0' + runSheetDatePlus1.Month()).right(2) + '-';
            haulDate += ('0' + runSheetDatePlus1.Day()).right(2);
        }
        return haulDate;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // * RETURN THE LIST OF "FACILITIES" THAT CAN BE SELECTED FOR A NEW RUNSHEET -> MIX OF STANDARD FACILITIES & WELL LOCATIONS * //
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    public static List<SelectOption> GetRunsheetFacilityList()
    {
        List<SelectOption> lFullFacilityList = new List<SelectOption>();
        List<Facility__c> lFacilities;
        List<Location__c> lWells;

        SelectOption oOneOption;
        String sFacilityName;
        String sWellName;

        // SEARCH FOR REGULAR FACILITIES -> STANDARD FACILITY OBJECT
        lFacilities = [SELECT Id, Name, Facility_Name_For_Fluid__c FROM Facility__c WHERE Fluid_Facility_Ind_Origin__c = true ORDER BY Facility_Name_For_Fluid__c, Name];
        System.debug(lFacilities);
        for(Facility__c oOneFacility : lFacilities)
        {
            sFacilityName = (oOneFacility.Facility_Name_For_Fluid__c == '' || oOneFacility.Facility_Name_For_Fluid__c == null) ? oOneFacility.Name : oOneFacility.Facility_Name_For_Fluid__c;
            oOneOption = new SelectOption(oOneFacility.Id, sFacilityName);
            lFullFacilityList.add(oOneOption);
        }

        // SEARCH FOR "OTHER" FACILITIES (NON STANDARD WELL LOCATIONS)
        lWells = [SELECT Id, Name, Location_Name_For_Fluid__c FROM Location__c WHERE Fluid_Location_Ind__c = true ORDER BY Location_Name_For_Fluid__c, Name];
        System.debug(lWells);
        for(Location__c oOneLocation : lWells)
        {
            sWellName = (oOneLocation.Location_Name_For_Fluid__c == '' || oOneLocation.Location_Name_For_Fluid__c == null) ? oOneLocation.Name : oOneLocation.Location_Name_For_Fluid__c;
            oOneOption = new SelectOption(oOneLocation.Id + RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER, sWellName);
            lFullFacilityList.add(oOneOption);
        }

        // Sort AND Assign Final List
        return SortSelectOptions(lFullFacilityList, SortSelectOptionBy.Label);
    }

    //////////////////////////////////////////////////////////////////////
    // * RETURN THE LIST OF AVAILABLE SERVICE TYPES BASED ON LOCATION * //
    //////////////////////////////////////////////////////////////////////

    public static List<SelectOption> GetServiceTypes(Location__c oLocation, Facility__c oFacility)
    {
        Schema.DescribeFieldResult oResult = Schema.sObjectType.FM_Run_Sheet__c.fields.Load_Type__c;
        List<Schema.PicklistEntry> lEntries = oResult.getPicklistValues();

        List<SelectOption> lServiceTypes = new List<SelectOption>();
        Boolean bIsFacility = (oFacility != null || (oLocation != null && oLocation.Fluid_Location_Ind__c == true)) ? true : false;
        Boolean bValid;

        for(Schema.PicklistEntry oOneEntry : lEntries)
        {
            bValid = true;

            // Validation Succeeded -> Add to Option List
            if(bValid == true)
            {
                lServiceTypes.add(new SelectOption(oOneEntry.getValue(), oOneEntry.getLabel()));
            }
        }

        return lServiceTypes;
    }

    ///////////////////////////////////////////////////////////
    // * CHECK USERS PERMISSION SET -> DETERMINE IF EXISTS * //
    ///////////////////////////////////////////////////////////

    public static Boolean VerifyPermissions(String sUserId, String sPermissionSet)
    {
        List<PermissionSetAssignment> lPermissions = [SELECT Id FROM PermissionSetAssignment WHERE AssigneeId = :sUserId AND PermissionSet.Name = :sPermissionSet];
        return (lPermissions.size() == RUNSHEET_SINGLE_RESULT) ? true : false;
    }

    ///////////////////////////////////////
    // * CHECK IF USER MATCHES PROFILE * //
    ///////////////////////////////////////

    public static Boolean VerifyProfile(String sProfileName)
    {
        Profile lProfile = [SELECT Id FROM Profile Where Name = :sProfileName LIMIT 1];
        return UserInfo.getProfileId() == lProfile.Id;
    }

    //////////////////////////////////////////////
    // * RETURN MAPPING OF UNIT CONFIGURATION * //
    //////////////////////////////////////////////

    public static Map<String, String> UnitConfigurationMaps()
    {
        Map<String, String> mapUnits = new Map<String, String>();

        mapUnits.put('T5X', '5');
        mapUnits.put('T6X', '6');
        mapUnits.put('T8X', '8');
        mapUnits.put('B3X', 'BJ');
        mapUnits.put('B6X', 'BJP');

        return mapUnits;
    }

    ////////////////////////////////////////////////////////////
    // * BUILD LOCATION MAPS BASED ON ROUTE NUMBER PROVIDED * //
    ////////////////////////////////////////////////////////////

    public static Map<String, List<SelectOption>> BuildLocationMaps(List<String> lSelectedWell, Set<String> setWells, String sRouteId)
    {
        List<Equipment_Tank__c> lTankLocations = (sRouteId != RUNSHEET_VALUE_NOT_SELECTED) ? GetLocationTankList(sRouteId) : new List<Equipment_Tank__c>();
        List<SelectOption> lLocationOptions = new List<SelectOption>();
        List<SelectOption> lSelectedWells = new List<SelectOption>();
        List<SelectOption> lAllWells = new List<SelectOption>();

        Map<String, List<SelectOption>> mapFinal = new Map<String, List<SelectOption>>();
        Map<Id, Location__c> mapLocations = GetLocationMap(sRouteId);
        //--- --- ---
        //MK - bugfix 17.6.2016
        Map<Id, Location__c> mapLocationsNotExistingTanks = GetLocationMapNotExistingTanks(sRouteId,mapLocations);
        mapLocations.putAll(mapLocationsNotExistingTanks);
        //--- --- ---

        List<AggregateResult> lRunsheetCount = [SELECT Well__r.Id RecordId, COUNT(Id) RunsheetCount FROM FM_Run_Sheet__c WHERE Date__c = TODAY GROUP BY Well__r.Id];
        Map<Id, Integer> mapRunsheetCount = new Map<Id, Integer>();

        for(AggregateResult oOneResult : lRunsheetCount)
        {
            mapRunsheetCount.put(String.valueOf(oOneResult.get('RecordId')), Integer.valueOf(oOneResult.get('RunsheetCount')));
        }

        setWells = (setWells == null) ? new Set<String>() : setWells;
        Location__c oOneLocation;
        SelectOption oOneOption;

        String sOptionId;
        String sOptionName;

        // Favorites List

        for(String sOneWellId : lSelectedWell)
        {
            oOneLocation = mapLocations.get(sOneWellId);

            if(oOneLocation != null)
            {
                sOptionId = oOneLocation.Id;
                sOptionName = oOneLocation.Name;

                oOneOption = new SelectOption(sOptionId, sOptionName);
                lSelectedWells.add(oOneOption);

                sOptionName = String.format('{0}~{1}', new String[]{'Favorite', oOneLocation.Name});

                if(mapRunsheetCount.get(oOneLocation.Id) > RUNSHEET_NO_RESULT)
                {
                    sOptionName = String.format('{0}~{1} ✓', new String[]{'Favorite', oOneLocation.Name});
                    oOneOption.setDisabled(true);
                }

                oOneOption.setLabel(sOptionName);
                lLocationOptions.add(oOneOption);
            }
        }


        // Standard List

        for(Equipment_Tank__c oSingleTank : lTankLocations)
        {
            if(!setWells.contains(oSingleTank.Equipment__r.Location__r.Id))
            {
                sOptionId = oSingleTank.Equipment__r.Location__r.Id;
                sOptionName = oSingleTank.Equipment__r.Location__r.Name;

                oOneOption = new SelectOption(sOptionId, sOptionName);
                lAllWells.add(oOneOption);

                sOptionName = String.format('{0}~{1}', new String[]{oSingleTank.Equipment__r.Location__r.Status__c, oSingleTank.Equipment__r.Location__r.Name});

                if(mapRunsheetCount.get(oSingleTank.Equipment__r.Location__r.Id) > RUNSHEET_NO_RESULT)
                {
                    sOptionName = String.format('{0}~{1} ✓', new String[]{oSingleTank.Equipment__r.Location__r.Status__c, oSingleTank.Equipment__r.Location__r.Name});
                    oOneOption.setDisabled(true);
                }

                oOneOption.setLabel(sOptionName);

                setWells.add(oSingleTank.Equipment__r.Location__r.Id);
                lLocationOptions.add(oOneOption);
            }
        }

        for(Location__c location: mapLocationsNotExistingTanks.values()){

            if(!setWells.contains(location.Id))
            {

                sOptionId = location.Id;
                sOptionName = location.Name;

                oOneOption = new SelectOption(sOptionId, sOptionName);
                lAllWells.add(oOneOption);


                    sOptionName = String.format('{0}~{1}', new String[]{location.Status__c, location.Name});

                    if(mapRunsheetCount.get(location.Id) > RUNSHEET_NO_RESULT)
                    {
                        sOptionName = String.format('{0}~{1} ✓', new String[]{location.Status__c, location.Name});
                        oOneOption.setDisabled(true);
                    }

                    oOneOption.setLabel(sOptionName);

                    setWells.add(location.Id);


                lLocationOptions.add(oOneOption);
            }
        }
        //--- --- ---


        // BUILD FULL MAP
        mapFinal.put(LOCATION_INDEX_ALL_WELLS, lAllWells);
        mapFinal.put(LOCATION_INDEX_SELECTED_WELLS, lSelectedWells);
        mapFinal.put(LOCATION_INDEX_LOCATION_LIST, lLocationOptions);

        return mapFinal;
    }

    /////////////////////////////////////////////////////////////////////////
    // * RETURN QUERY LIST RESULT FOR ALL TANKS FROM LOCATIONS PER ROUTE * //
    /////////////////////////////////////////////////////////////////////////

    public static List<Equipment_Tank__c> GetLocationTankList(String sRouteId)
    {
        String sQuery = QUERY_LOCATION_LIST_FROM_TANKS.replace('!!ROUTENUM!!', sRouteId);
        return (sRouteId != RUNSHEET_VALUE_NOT_SELECTED) ? Database.query(sQuery) : new List<Equipment_Tank__c>();
    }

    /////////////////////////////////////////////////////////////////////////
    // * RETURN QUERY LIST RESULT FOR ALL TANKS FROM A SPECIFIC LOCATION * //
    /////////////////////////////////////////////////////////////////////////

    public static List<Equipment_Tank__c> GetLocationTanks(String sLocationId)
    {
        String sQuery = QUERY_SINGLE_LOCATION_TANKS.replace('!!LOCATION!!', sLocationId);
        return Database.query(sQuery);
    }

    ////////////////////////////////////////////////////////
    // * RETURN MAP OF LOCATIONS -> ID WITH NAME FIELDS * //
    ////////////////////////////////////////////////////////

    public static Map<Id, Location__c> GetLocationMap(String sRouteId)
    {
        List<Equipment_Tank__c> lTankList = GetLocationTankList(sRouteId);
        Set<Id> setLocationId = new Set<Id>();

        for(Equipment_Tank__c oOneTank : lTankList)
        {
            if(!setLocationId.contains(oOneTank.Equipment__r.Location__r.Id))
            {
                setLocationId.add(oOneTank.Equipment__r.Location__r.Id);
            }
        }

        List<Location__c> lLocations = [SELECT  Id, Name, Cost_Center__c, Senior__c, Well_Orientation__c, Current_Well_Status__c, Location_Name_for_Fluid__c,
                                                Status__c, Unit_Configuration__c, Hazardous_H2S__c, Surface_Location__c,
                                                Operating_Field_AMU__c, Operating_Field_AMU__r.Operating_District__c,
                                                Operating_Field_AMU__r.Operating_District__r.Business_Unit__c, Route__r.Field_Senior__r.FirstName,
                                                Route__r.Field_Senior__r.LastName, Route__r.Field_Senior__r.Id, PVR_AVGVOL_5D_SAND__c, PVR_AVGVOL_30D_OIL__c,
                                                PVR_AVGVOL_30D_WATER__c, PVR_AVGVOL_30D_SAND__c, Well_Type__c, Statusicon__c, Fluid_Location_Ind__c
                                        FROM Location__c
                                        WHERE Id IN :setLocationId];
        return new Map<Id, Location__c>(lLocations);
    }

    public static Map<Id, Location__c> GetLocationMapNotExistingTanks(String sRouteId, Map<Id, Location__c> locationListWithTanks)
    {

        Set<Id> locationIds = locationListWithTanks.keySet();

        List<Location__c> lLocations = [SELECT  Id, Name, Cost_Center__c, Senior__c, Well_Orientation__c, Current_Well_Status__c, Location_Name_for_Fluid__c,
                                                Status__c, Unit_Configuration__c, Hazardous_H2S__c, Surface_Location__c,
                                                Operating_Field_AMU__c, Operating_Field_AMU__r.Operating_District__c,
                                                Operating_Field_AMU__r.Operating_District__r.Business_Unit__c, Route__r.Field_Senior__r.FirstName,
                                                Route__r.Field_Senior__r.LastName, Route__r.Field_Senior__r.Id, PVR_AVGVOL_5D_SAND__c, PVR_AVGVOL_30D_OIL__c,
                                                PVR_AVGVOL_30D_WATER__c, PVR_AVGVOL_30D_SAND__c, Well_Type__c, Statusicon__c, Fluid_Location_Ind__c
                                        FROM Location__c
                                        WHERE Id NOT IN :locationIds AND
                                            Route__c =: sRouteId AND
                                            Functional_Location_Category__c IN :RUNSHEET_FUNCTIONAL_LOCATION_CATEGORIES AND
                                            Status__c IN :RUNSHEET_WELL_INCLUDED_STATUSES AND
                                            Well_Type__c IN :RUNSHEET_WELL_TYPES
                                        ORDER BY Status__c, Name];

        return new Map<Id, Location__c>(lLocations);
    }

    /////////////////////////////////////////////////////////
    // * RETURN THE MAPPING OF WELL'S UNIT CONFIGURATION * //
    /////////////////////////////////////////////////////////

    public static String GetUnitConfigurationMapping(String sUnitConfiguration)
    {
        return (RUNSHEET_UNITCONFIG_MAP.containsKey(sUnitConfiguration)) ? RUNSHEET_UNITCONFIG_MAP.get(sUnitConfiguration) : null;
    }

    /////////////////////////////////////////////////////////
    // * RETURN THE MAPPING OF WELL'S UNIT CONFIGURATION * //
    /////////////////////////////////////////////////////////

    public static List<SelectOption> GetTankLabels(String srcType) {
        List<SelectOption> lTankLabels = new List<SelectOption>();
        For (Map<String, String> tank : TANK_LABELS) {
            if (srcType == 'all') {
                lTankLabels.add(new SelectOption(tank.get('label'), tank.get('label')));
            }
            else {
                if (srcType == tank.get('type'))
                    lTankLabels.add(new SelectOption(tank.get('label'), tank.get('label')));
            }
        }

        return lTankLabels;
    }



    /////////////////////////
    // * CUSTOM REDIRECT * //
    /////////////////////////

    public static PageReference FluidRedirect(String sNewLocation, Boolean bSetRedirect)
    {
        PageReference oPage = new PageReference(URL.getSalesforceBaseUrl().toExternalForm() + '/' + sNewLocation);
        oPage.setRedirect(bSetRedirect);

        return oPage;
    }

    /////////////////////////////////////////////////////////////////////////////////////
    // * RETURN THE 3 LETTERED OBJECT ID FOR THE RUNSHEET (CAN VARY PER ENVIRONMENT) * //
    /////////////////////////////////////////////////////////////////////////////////////

    public static String GetRunsheetObjectId()
    {
        Schema.DescribeSObjectResult oResult = FM_Run_Sheet__c.sObjectType.getDescribe();
        return oResult.getKeyPrefix();
    }

    /////////////////////////////////////////
    // * Get Facility Summary Information *//
    /////////////////////////////////////////

    public static Map<Id, FM_Truck_Trip__c> truckTripsBookedOrDispatched {
        get {
            if(truckTripsBookedOrDispatched == null || truckTripsBookedOrDispatched.isEmpty()) {
                truckTripsBookedOrDispatched = new Map<Id, FM_Truck_Trip__c>([SELECT Id, Product__c, Shift__c, Load_Weight__c, Facility__c,
                                                                                     Facility_Type__c, Facility_Lookup__c, Location_Lookup__c
                                                                              FROM FM_Truck_Trip__c
                                                                              WHERE ((Planned_Dispatch_Date__c = TODAY AND Shift__c = 'Night')  OR (Planned_Dispatch_Date__c = TOMORROW AND Shift__c = 'Day'))
                                                                              AND Facility__c != ''
                                                                              AND Truck_Trip_Status__c IN :FACILITY_SUMMARY_STATUS_LIST
                                                                              ORDER BY Facility__c, Product__c LIMIT 5000]);
            }
            return truckTripsBookedOrDispatched;
        }
        public set;
    }

    public static List<Facility_Capacity__c> facilityCapacitySummaryList {
        get {
            //if(facilityCapacitySummaryList == null || facilityCapacitySummaryList.isEmpty()){
                facilityCapacitySummaryList = [SELECT Id, Facility__c, Well_Location__c, Facility_Name__c, Facility_Type__c, Total_Capacity_Oil__c, Total_Capacity_Water__c
                                               FROM Facility_Capacity__c LIMIT 5000];
            //}
            return facilityCapacitySummaryList;
        }
        public set;
    }

    public static Map<String, FM_FacilitySummary.FacilityDataWrapper> GetFacilityCapacitySummaryMap(List<FM_Truck_Trip__c> truckTripsFromPage) {
        Map<String, FM_FacilitySummary.FacilityDataWrapper> allFacilitySummaryDataMap = new Map<String, FM_FacilitySummary.FacilityDataWrapper>();
        List<FM_Truck_Trip__c> truckTripsUsedInCalculations = new List<FM_Truck_Trip__c>();

        Map<String, Integer> mapFacilityCapacity = new Map<String, Integer>();
        FM_FacilitySummary.FacilityDataWrapper oOneWrapper;

        String sKey = '';
        Integer iTotalFound = 0;

        for(Facility_Capacity__c facilityCapacity : facilityCapacitySummaryList)
        {
            Id destinationId = (facilityCapacity.Facility_Type__c == 'Facility') ? facilityCapacity.Facility__c : facilityCapacity.Well_Location__c;
            mapFacilityCapacity.put(destinationId + '-O', Integer.valueOf(facilityCapacity.Total_Capacity_Oil__c));
            mapFacilityCapacity.put(destinationId + '-W', Integer.valueOf(facilityCapacity.Total_Capacity_Water__c));
        }

        //Create consolidated truck trip list to be used in calculations
        //truckTripsUsedInCalculations = ConsolidateTruckTripList(truckTripsBookedOrDispatched, truckTripsFromPage);


        ////Add miscellaeneous truck trips from view for dynamic behaviour
        truckTripsUsedInCalculations.addAll(truckTripsBookedOrDispatched.values());
        if(truckTripsFromPage != null) truckTripsUsedInCalculations.addAll(truckTripsFromPage);

        for(FM_Truck_Trip__c oOneTrip : truckTripsUsedInCalculations)
        {

            sKey = ((oOneTrip.Facility_Type__c == 'Facility') ? oOneTrip.Facility_Lookup__c : oOneTrip.Location_Lookup__c) + '-' + oOneTrip.Product__c;
            iTotalFound = (mapFacilityCapacity.get(sKey) == null) ? 0 : mapFacilityCapacity.get(sKey);

            // No Wrapper Found --> Create
            if(allFacilitySummaryDataMap.get(sKey) == null)
            {
                oOneWrapper = new FM_FacilitySummary.FacilityDataWrapper(
                    (oOneTrip.Facility_Type__c == 'Facility') ? oOneTrip.Facility_Lookup__c : oOneTrip.Location_Lookup__c,
                    oOneTrip.Facility__c,
                    oOneTrip.Product__c,
                    iTotalFound);
                allFacilitySummaryDataMap.put(sKey, oOneWrapper);
            }
            else
            {
                oOneWrapper = allFacilitySummaryDataMap.get(sKey);
            }

            if(oOneTrip.Shift__c.toLowerCase() == 'night')
            {
                oOneWrapper.IncrementCapacityNight(Integer.valueOf(oOneTrip.Load_Weight__c));
            }
            else if(oOneTrip.Shift__c.toLowerCase() == 'day')
            {
                oOneWrapper.IncrementCapacityDay(Integer.valueOf(oOneTrip.Load_Weight__c));
            }

            oOneWrapper.IncrementLoads(oOneTrip.Shift__c);

            // Update Wrapper
            allFacilitySummaryDataMap.put(sKey, oOneWrapper);
        }

        return allFacilitySummaryDataMap;
    }

    /**
    Return query string generated from list of String for Query: "WHERE Column IN ([returned string])"
    */
    public static String getStringQueryFromStringList(List<String> items) {
        String queryString = '';
        for (String item : items) {
            if (queryString != '') queryString += ',';
            queryString += '\'' + item +'\'';
        }
        return queryString;
    }

    /**
    * Easy to use function for consolidating truck trips statuses
    * Dispatched - Dispatched, Completed, Add On, Given Back
    * all other statuses are returned as normal
    */
    public static String getConsolidatedStatus(String truckTripStatus) {
        return (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED || truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_GIVENBACK ||
                truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_ADDON || truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_COMPLETED) ? 
                FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED : truckTripStatus;
    }

    /**
    * Easy to use function for consolidating status string to use
    * in query for trucktrips
    */
    public static String getStatusQueryString(String truckTripStatus) {
        String dispatchedFilter = '(\'' + FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED + '\',\'' + FM_Utilities.TRUCKTRIP_STATUS_GIVENBACK + '\',\'' +
            FM_Utilities.TRUCKTRIP_STATUS_ADDON + '\',\'' + FM_Utilities.TRUCKTRIP_STATUS_COMPLETED + '\')';
        String normalFilter = '(\'' + truckTripStatus + '\')';
        return (truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED || truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_GIVENBACK ||
                truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_ADDON || truckTripStatus == FM_Utilities.TRUCKTRIP_STATUS_COMPLETED) ? 
                dispatchedFilter : normalFilter;
    }  

    /**
    * Easy to use function to get field Id
    */
    webservice static String getMetadataFieldId(String customObjectApiName, String fieldLabel) {
        String prefix = Schema.getGlobalDescribe().get(customObjectApiName).getDescribe().getKeyPrefix();
        PageReference pr = new PageReference('/' + prefix + '/e?nooverride=1');
        string html;
        Blob pageContent = pr.getContent();
        if(pageContent != null) {
            html = pageContent.toString();
        }
        Matcher macher = Pattern.compile('<label for="(.*?)">(<span class="requiredMark">\\*</span>|<span class="assistiveText">\\*</span>)?(.*?)</label>').matcher(html);
        Map<String, String> fieldMap = new Map<String, String>();
        while(macher.find()) {
            String label = macher.group(3);
            String fldId = macher.group(1);
            system.debug(label+'############'+fldId);
            fieldMap.put(label, fldId);
        }
        return fieldMap.get(fieldLabel);
    }

}